/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/UnitTests/JUnit5TestClass.java to edit this template
 */
package com.jcg.executorserviceexample;

import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.*;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

/**
 *
 * @author omozegieaziegbe
 */
public class ExecutorServiceExampleTest {
    
    @Test
    public void testExecutorServiceWithLongRunningCalculation() throws InterruptedException {
        
        ExecutorService executor = Executors.newSingleThreadExecutor();
        CountDownLatch latch = new CountDownLatch(1);

        // Create a runnable with a long-running calculation
        MyRunnable task = new MyRunnable(1, 1000000000L) {
            @Override
            public void run() {
                super.run();
                latch.countDown();
            }
        };

        // Submit the task to the executor
        executor.submit(task);

        // Wait for the task to complete
        assertTrue(latch.await(2, TimeUnit.MINUTES));

        // Verify the result
        long expected = (1000000000L * (1000000000L + 1)) / 2;
        assertEquals(expected, task.getResult());

        // Shutdown the executor
        executor.shutdown();
    }
    
}
