/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/UnitTests/JUnit5TestClass.java to edit this template
 */
package com.jcg.futureexample;

import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.*;
import java.util.concurrent.Future;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 *
 * @author omozegieaziegbe
 */
public class FutureExampleTest {
    
    @Test
    public void testFutureWithLongRunningCalculation() throws Exception {
        
        ExecutorService executor = Executors.newSingleThreadExecutor();

        // Create an instance of MyRunnable with a long-running calculation
        MyRunnable task = new MyRunnable(1, 1000000000L);

        // Submit the task to the executor and get a Future
        Future<?> future = executor.submit(task);

        // Wait for the task to complete and get the result
        future.get(); // Blocks until the task completes

        // Verify the result
        long expected = (1000000000L * (1000000000L + 1)) / 2;
        assertEquals(expected, task.getResult());

        // Shutdown the executor
        executor.shutdown();
    }
    
}
