/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/UnitTests/JUnit5TestClass.java to edit this template
 */
package com.jcg.shutdownexample;

import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

/**
 *
 * @author omozegieaziegbe
 */
public class ShutDownExampleTest {
    
    @Test
    public void testShutdownWithLongRunningCalculation() throws InterruptedException {
        
        ExecutorService executor = Executors.newSingleThreadExecutor();

        // Create an instance of MyRunnable with a long-running calculation
        MyRunnable task = new MyRunnable(1, 1000000000L);

        // Submit the task to the executor
        executor.submit(task);

        // Shutdown the executor
        executor.shutdown();

        // Wait for existing tasks to complete
        assertTrue(executor.awaitTermination(2, TimeUnit.MINUTES));

        // Verify the result
        long expected = (1000000000L * (1000000000L + 1)) / 2;
        assertEquals(expected, task.getResult());
    }
    
}
